From 6532d55260b88862772f3bef1b86fd1539412d3a Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 722/1001] Convert the library widget


---

diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index ac7ddfc..92b4bde 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -18,12 +18,12 @@ class TestLibrary(hubs.tests.test_widgets.WidgetTest):
                 "urls": "ralph/"
             },
             "data": {
-                u"edit_url": u"/ralph/%d/edit" % widget.idx,
-                u"source_url": u"/source/library",
-                u"urls": [
-                    u"<a href=\"ralph/\">ralph/</a>"
+                "edit_url": "/ralph/%d/edit" % widget.idx,
+                "source_url": "/source/library",
+                "urls": [
+                    "<a href=\"ralph/\">ralph/</a>"
                 ],
-                u"widget_url": u"/ralph/%d" % widget.idx,
+                "widget_url": "/ralph/w/library/%d/" % widget.idx
             },
             "description": None,
             "hub": "ralph",
@@ -32,5 +32,4 @@ class TestLibrary(hubs.tests.test_widgets.WidgetTest):
             "left": False,
             "plugin": "library"
         }
-
         self.assertDictEqual(data['data'], expected_dict['data'])
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
new file mode 100644
index 0000000..09ec390
--- /dev/null
+++ b/hubs/widgets/library/__init__.py
@@ -0,0 +1,38 @@
+from __future__ import unicode_literals
+
+from hubs import validators
+from hubs.widgets import clean_input
+from hubs.widgets.chrome import panel
+from hubs.widgets.base import Widget, WidgetView
+
+
+class Library(Widget):
+
+    name = "library"
+    position = "both"
+    arguments = [dict(
+        name="urls",
+        label="URLs",
+        default=None,
+        validator=validators.text,
+        help="A comma separated list of URLs to add to the library. "
+             "External links must include the whole link "
+             "(starting with http...)."
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/library.html"
+    chrome = panel("Library")
+
+    def get_context(self, instance, *args, **kwargs):
+        urls = [
+            clean_input.clean(
+                '<a href="{0}">{0}</a>'.format(u.strip()))
+            for u in instance.config.get('urls', '').split(',')
+            if u.strip()
+        ]
+        return dict(urls=urls)

